﻿using System;
using OpcLabs.BaseLib.LiveMapping;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.LiveMapping;
using System.ComponentModel;

using System.Runtime.CompilerServices;
using Mts.Opc.BaseTypes;
using OpcLabs.EasyOpc.UA.LiveBinding;
using OpcLabs.EasyOpc.UA.Extensions;
using PlcModel.baseTypes;
using PlcModel.types;

namespace PlcModel.PLC
{

    [UANamespace("http://www.siemens.com/simatic-s7-opcua")]
    [UAType]
    public class DT_DATA : DisplayData
    {
        private ArrUDT_Counters_ARRAY _ArrUDT_Counters;
        [UANode(BrowsePath = ".ArrUDT_Counters", NodeId = "nsu=http://www.siemens.com/simatic-s7-opcua;ns=3;s=\"DATA\".\"ArrUDT_Counters\"")]
        public ArrUDT_Counters_ARRAY ArrUDT_Counters
        {
            get { return this._ArrUDT_Counters ?? (this._ArrUDT_Counters = new ArrUDT_Counters_ARRAY()); }
            set
            {
                if (value == this._ArrUDT_Counters) return;
                this._ArrUDT_Counters = value;
                this.OnPropertyChanged();
            }
        }


        [UAType()]
        [UANamespace("http://www.siemens.com/simatic-s7-opcua")]
        [UANodeIdTemplate("$(ParentNodeID)[$(BrowseName)]")]
        public class ArrUDT_Counters_ARRAY
        {

            private UDT_Counters m_Index_8;

           // [UANode(BrowsePath = ".[nsu=http://www.siemens.com/simatic-s7-opcua;s=&8]")]
            [UANode(BrowsePath = ".&8]")]
            public virtual UDT_Counters Index_8
            {
                get
                {
                    if (m_Index_8 == null)
                    {
                        this.m_Index_8 = new UDT_Counters();
                    }
                    return this.m_Index_8;
                }
                set
                {
                    this.m_Index_8 = value;
                }
            }
        }




        /*        THIS THROW EXCEPTION....        */

        //private UDT_Counters[] _ArrUDT_Counters  = new UDT_Counters[8];
        //[UANode(BrowsePath = ".ArrUDT_Counters")]
        //[UAData(Kind = UADataMappingKind.Value, ValueType = typeof(UDT_Counters[]))]
        //public UDT_Counters[] ArrUDT_Counters
        //{
        //    get { return this._ArrUDT_Counters; }
        //    set
        //    {
        //        this._ArrUDT_Counters = value;
        //        this.OnPropertyChanged();
        //    }
        //}



        /*           THIS WORKS        */

        private UDT_Counters _UDT_Counters;
        [UANode(BrowsePath = ".UDT_Counters")]
        public UDT_Counters udt_Counters
        {
            get
            {
                if (_UDT_Counters == null)
                {
                    _UDT_Counters = new UDT_Counters();
                }
                return _UDT_Counters;
            }

            set
            {
                _UDT_Counters = value;
            }
        }


    }
}
