﻿using OpcLabs.EasyOpc.UA.LiveMapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PlcModel.baseTypes;

namespace PlcModel.PLC
{

    [UANamespace("http://www.siemens.com/simatic-s7-opcua")]
    [UAType]
    public class DT_DataBlocksGlobal : DisplayData
    {

        private DT_DATA m_Data;
        [UANode(BrowsePath = "/DATA", NodeId = "nsu=http://www.siemens.com/simatic-s7-opcua;ns=3;s=\"DATA\"")]
        public DT_DATA Data
        {
            get
            {
                if (m_Data == null)
                {
                    m_Data = new DT_DATA();
                }
                return m_Data;
            }

            set
            {
                m_Data = value;
                this.OnPropertyChanged();
            }

        }

    }

}
