﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Runtime.CompilerServices;
using System.ComponentModel;

namespace PlcModel.baseTypes
{
    public class DisplayData : INotifyPropertyChanged
    {

        #region INotifyPropertyChanged - Implamentation

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged([CallerMemberName] string propertyName = "")
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion //end INotifyPropertyChanged - Implamentation 


        public dynamic GetNodeCustomAttributes()
        {
            return this.GetType().CustomAttributes;
        }

        public dynamic GetNodeCustomAttributesData()
        {
            return this.GetType().GetCustomAttributesData();
        }

    }

}
