﻿using Mts.Opc.BaseTypes;
using OpcLabs.EasyOpc.UA.LiveMapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PlcModel.baseTypes;

namespace PlcModel.types
{

    [UANamespace("http://www.siemens.com/simatic-s7-opcua")]
    [UAType]
    public class UDT_Counters : DisplayData
    {
        private Ua_UInt32 _AsDWord;

        [UANode(BrowsePath = ".AsDWord")]
        public Ua_UInt32 AsDWord
        {
            get
            {
                if (_AsDWord == null)
                {
                    _AsDWord = new Ua_UInt32();
                }
                return _AsDWord;
            }

            set
            {
                _AsDWord = value;
            }
        }


        private Ua_UInt16 m_AsInt;
        [UANode(BrowsePath = ".AsInt")]
        public virtual Ua_UInt16 AsInt
        {
            get
            {
                if (m_AsInt == null)
                {
                    m_AsInt = new Ua_UInt16();
                }
                return this.m_AsInt;
            }
            set
            {
                this.m_AsInt = value;
            }
        }


        private Ua_String m_AsString;
        [UANode(BrowsePath = ".AsString")]
        public virtual Ua_String AsString
        {
            get
            {
                if (m_AsString == null)
                {
                    m_AsString = new Ua_String(this);
                }
                return this.m_AsString;
            }
            set
            {
                this.m_AsString = value;
            }
        }

    }

}
